
const canvas = document.getElementById("myCanvas");
const ctx = canvas.getContext("2d");

let x,y;
let v,u;
let dv,du;
let av,au;
let f;
let r;
let d = { width: canvas.width, height: canvas.height };

function init() {
    v=0;u=0;
	f=0;
	av=3;//3
    au=4;//3	
    dv=av;
    du=au;
	r=2;//2
	buffer = createBuffer(d.width, d.height);
    drawToBuffer();
}

function createBuffer(width, height) {
    const offscreenCanvas = document.createElement('canvas');
    offscreenCanvas.width = width;
    offscreenCanvas.height = height;
    return offscreenCanvas;
}

function drawToBuffer() {
    const g = buffer.getContext("2d");
	
		g.fillStyle = "white";
        g.fillRect(0, 10, d.width, d.height - 10);
		g.strokeStyle = "black";
        g.beginPath();
		g.moveTo(0,d.height/6);
        g.lineTo(d.width,d.height/6);
		g.moveTo(0,d.height/2);
        g.lineTo(d.width,d.height/2);
		g.moveTo(0,5*d.height/6);
        g.lineTo(d.width,5*d.height/6);
		g.stroke();
		g.fillStyle = "black";
		g.fillText("y",10,45);
		
		if(au==4){
			g.fillText("Vg＞Vp",d.width/2-10,45);g.fillText("y'1",10,265);g.fillText("y+y'1",10,455);
			}
		if(au==3){
			g.fillText("Vg＝Vp",d.width/2-10,45);g.fillText("y'2",10,265);g.fillText("y+y'2",10,455);
		    }
		if(au==2.8){
			g.fillText("Vg＜Vp",d.width/2-10,45);g.fillText("y'3",10,265);g.fillText("y+y'3",10,455);
		    }
		if(au==2){
			g.fillText("Vg＜0",d.width/2-10,45);g.fillText("y'4",10,265);g.fillText("y+y'4",10,455);
		    }
		
		for (x=0;x<=d.width;x=x+r){
			y=-(d.height/18)*Math.sin((x-v)*Math.PI*10/300)+(d.height/6);
		g.fillStyle = "blue";
		g.beginPath();     
        g.arc(x, y, r / 2, 0, Math.PI * 2);
        g.fill();
		}
		for (x=0;x<=d.width;x=x+r){
			y=-(d.height/18)*Math.sin((x-u)*Math.PI*11/300)+(d.height/2);
		g.fillStyle = "blue";
		g.beginPath();     
        g.arc(x, y, r / 2, 0, Math.PI * 2);
        g.fill();
		}
		for (x=0;x<=d.width;x=x+r){
			y=-(d.height/18)*Math.sin((x-v)*Math.PI*10/300)-(d.height/15)*Math.sin((x-u)*Math.PI*11/300)+(5*d.height/6);
		g.fillStyle = "blue";
		g.beginPath();     
        g.arc(x, y, r / 2, 0, Math.PI * 2);
        g.fill();
		}
}
		
function move() {
        dv=f*av;
		v=v+dv;
		du=f*au;
		u=u+du;
}

function start() {
    setInterval(function() {
        move();
        drawToBuffer();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(buffer, 0, 0);
    }, 30);
}

document.getElementById('Vgp').addEventListener('click', Vgp);
document.getElementById('VgVp').addEventListener('click', VgVp);
document.getElementById('Vpg').addEventListener('click', Vpg);
document.getElementById('Vg0').addEventListener('click', Vg0);
document.getElementById('Run').addEventListener('click', Run);
document.getElementById('Stop').addEventListener('click', Stop);




function Vgp() {
       au=4;
}
function VgVp() {
        au=3;
}
function Vpg() {
        au=2.8;
}
function Vg0() {
        au=2;
}
function Run() {
        f=1;
}
function Stop() {
        f=0;
}


init();
start();




